/************************************************************************************/
/*  Program name CAPFNDIMP_REQ_SET_PGRM_PARAM.sql                                   */
/*  Creater:  Chan Billy Ka Keung (PCCW - UniHub)                                   */
/*************   History   *************************                                */
/* 01 FEB, 2006   CHAN Billy Ka Keung         First created                         */
/************************************************************************************/

SET SERVEROUTPUT ON SIZE 1000000;

DECLARE

	lv_PrOG_ID		VARCHAR2(100) 	:=	'CAPFNDIMP_REQ_SET_PGRM_PARAM';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FND_REQ_SET_PGRM_PARAM;

	lv_Next_Seq_ID	NUMBER;

BEGIN
	--RENAME
	UPDATE
		FND_REQUEST_SET_PROGRAM_ARGS
	SET
		DESCRIPTIVE_FLEXFIELD_NAME	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(DESCRIPTIVE_FLEXFIELD_NAME,1,4),DESCRIPTIVE_FLEXFIELD_NAME),
		APPLICATION_COLUMN_NAME		=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(APPLICATION_COLUMN_NAME,1,4),APPLICATION_COLUMN_NAME)
	WHERE	(Application_ID,Request_Set_ID,Request_Set_Program_ID,Descriptive_Flex_Appl_ID,Descriptive_FlexField_Name,Application_Column_Name) IN
			(
			SELECT
				Application_ID,Request_Set_ID,Request_Set_Program_ID,Descriptive_Flex_Appl_ID,Descriptive_FlexField_Name,Application_Column_Name
			FROM
				CRST_FND_REQ_SET_PGRM_PARAM
			);

	FOR C1 IN Cur_F LOOP
		BEGIN

			SELECT	FND_REQUEST_SET_PROGRAMS_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO CRST_FND_REQ_SET_PGRM_P_MAP
			VALUES
			(
			C1.APPLICATION_ID,
			C1.REQUEST_SET_ID,
			C1.REQUEST_SET_PROGRAM_ID,
			C1.DESCRIPTIVE_FLEX_APPL_ID,
			CAPBRIMP_MAPPING.RenameStr(SUBSTR(C1.DESCRIPTIVE_FLEXFIELD_NAME,1,4),C1.DESCRIPTIVE_FLEXFIELD_NAME),
			CAPBRIMP_MAPPING.RenameStr(SUBSTR(C1.APPLICATION_COLUMN_NAME,1,4),C1.APPLICATION_COLUMN_NAME),
			C1.APPLICATION_ID,
			C1.REQUEST_SET_ID,
			lv_Next_Seq_ID,
			C1.DESCRIPTIVE_FLEX_APPL_ID,
			C1.DESCRIPTIVE_FLEXFIELD_NAME,
			C1.APPLICATION_COLUMN_NAME
			);

			INSERT INTO FND_REQUEST_SET_PROGRAM_ARGS
			VALUES
			(
			C1.APPLICATION_ID,
			CAPBRIMP_MAPPING.GetRequestSetIDMapping(C1.REQUEST_SET_ID),		--REQUEST_SET_ID,
			lv_Next_Seq_ID,
			C1.DESCRIPTIVE_FLEX_APPL_ID,
			C1.DESCRIPTIVE_FLEXFIELD_NAME,
			C1.APPLICATION_COLUMN_NAME,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_BY_NAME),				--LAST_UPDATED_BY,
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_BY_NAME),					--CREATED_BY,
			C1.LAST_UPDATE_LOGIN,
			C1.DISPLAY_FLAG,
			C1.INSERT_FLAG,
			C1.UPDATE_FLAG,
			C1.DEFAULT_TYPE,
			C1.DEFAULT_VALUE,
			C1.SHARED_PARAMETER_NAME
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_lINe(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count		:= lv_Scc_Count + 1;
	END LOOP;

	IF lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count - lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
